# ==== enigmaM3.py : enigma M3 en python

import sys
import enigmaM3noAdvance
import string	
import getopt

ALPHA = string.ascii_uppercase
# ===================================
def is_maj(car):
	if string.ascii_uppercase.find(car) == -1: 
		return 0
	else:
		return 1
# ===================================
def rotorMove( rotor, advance):
    global GRUND
    if   rotor == 'R':
        i = ALPHA.find( GRUND[2] )
        x = ALPHA[(26 + i + advance )%26]
        GRUND = GRUND[:2] + x
    elif rotor == 'M':
        i = ALPHA.find( GRUND[1] )
        x = ALPHA[(26 + i + advance )%26]
        GRUND = GRUND[:1] + x + GRUND[2:3]
    elif rotor == 'L':
        i = ALPHA.find( GRUND[0] )
        x = ALPHA[(26 + i + advance )%26]
        GRUND = x + GRUND[1:3]
# ===================================
def help():
    print("+ -> step_forward_Right,  - -> step_backward_Right")
    print("> -> step_forward_Middle, < -> step_backward_Middle")
    print("[ -> step_forward_Left,   ] -> step_backward_Left")
    print("! -> debug_mode_on,       : -> debug_mode_off")
    print("? -> print_help,          . -> exit")
# ===================================
def usage():
    print("Usage:")
    print(" -h          This help")
    print(" -W I,II,III The Walzenlage (no default)")
    print(" -U B        Umkehrwalze (B by default)")
    print(" -R AAA      The Ringstellung (AAA by default)")
    print(" -G AAA      The Grundstellung (AAA by default)")
# ====================================================
# Manage options
try:
    opts, args = getopt.getopt(sys.argv[1:],
        "hW:U:R:G:", ["help", "walzenlage=", "umkehrwalze=", 
        "ringstellung=",  "grundstellung=" ])
except getopt.GetoptError as err:
    usage()
    sys.exit(2)

UKW    = "B"
LEFT   = "I"
MIDDLE = "II"
RIGHT  = "III"
STECKS = ""
RING   = "AAA"
GRUND  = "AAA"
DEBUG  = False
WALZENLAGE = ""

for o, a in opts:
    if o == "-v":
        DEBUG = True
    elif o in ("-h", "--help"):
        usage()
        sys.exit()
    elif o in ("-W", "--walzenlage"):
        WALZENLAGE = a
        LEFT,MIDDLE,RIGHT = a.split(',')
    elif o in ("-G", "--grund"):
        GRUND = a
    elif o in ("-R", "--ring"):
        RING = a
    elif o in ("-U", "--ukw"):
        UKW = a
    else:
        assert False, "unhandled option"

if WALZENLAGE == "":
    usage()
    sys.exit(1)

#==================== Start of the program
c = enigmaM3noAdvance.Enigma(UKW,LEFT,MIDDLE,RIGHT, STECKS, RING, GRUND, DEBUG)

while True:
    print(GRUND, end="")
    c.setGrund( GRUND )
    saisie = input(" ? ")
    if saisie == "": 
        help()
        continue
    car = saisie[0]
    if car == ".": break
    if car == "?": 
        help()
        continue
    car = car.upper()
    if is_maj( car ): 
        crypto = c.encode( car )
        print( car, "->", crypto )
        continue
    for car in saisie:
        if car == "+": rotorMove('R',+1)
        if car == "-": rotorMove('R',-1)
        if car == ">": rotorMove('M',+1)
        if car == "<": rotorMove('M',-1)
        if car == ")": rotorMove('L',+1)
        if car == "(": rotorMove('L',-1)

